:: GRC_make.bat mpc_file make_file nmake_opts target_dir
::	- converts mpc_file to makefile, then make the makefile.
::
:: Author: 
::	Attila Vizhanyo - viza@isis.vanderbilt.edu
::
:: Arguments:
::	1: mpc_file name of the input mpc_file
::	2: make_file name of the output makefile (generated)
::	3: nmake_opts: nmake command line options
::	4: target_dir: makefile destination directory

:BEGIN
set MPCFILE=%1
set MAKEFILE=%2
set NMAKE_OPTS=%3
set TARGET_DIR=.
IF  "%4" == "" GOTO SkipTargetDir
set TARGET_DIR=%4
:SkipTargetDir
echo on
call "%VS90COMNTOOLS%vsvars32.bat"
if %ERRORLEVEL% NEQ 0 goto VCERROR

:: Generate nmake makefile
"%UDM_3RDPARTY_PATH%\mpc\mpc.exe" -type nmake -into %TARGET_DIR% %MPCFILE%
if %ERRORLEVEL% NEQ 0 goto MPCERROR

:: invoke nmake.exe
echo on
cd /D %TARGET_DIR%
nmake.exe -f  %MAKEFILE% CFG=%NMAKE_OPTS% all
if %ERRORLEVEL% NEQ 0 goto MKERROR
goto CLEAN

:VCERROR
echo "ERROR: Please add <Microsoft Visual Studio 9 Dir>/Common7/Tools directory to system path."
pause
exit 1 

:MKERROR
echo "ERROR: nmake.exe failed."
pause
exit 2

:MPCERROR
echo "ERROR: mpc.exe failed."
pause
exit 3

:CLEAN

:END
exit 0
