REM Create the GReAT test Log file
	for /F "tokens=1-4 delims=/- " %%A in ('date/T') do set GREAT_TEST_LOGF="%GREAT_PATH%\samples\GReATTestLog_%%B_%%C.txt"

	echo ******************************************************************************** >  %GREAT_TEST_LOGF%
	echo * GReAT Samples testing started %DATE% %TIME% >> %GREAT_TEST_LOGF%
	echo ******************************************************************************** >>  %GREAT_TEST_LOGF%

REM ======House2Order Sample====================
:House2Order
echo * Run Sample House2Order >>  %GREAT_TEST_LOGF%

SET TESTSFAILED=0
SET ERRORLEV=0
cd "%GREAT_PATH%/Samples/House2Order"

call ..\runGReATSample.bat House2Order.mga config.mga House2Order.udm myOrder1.mga correct_myorder1_model.mga GS_Order.xml GenHouse2Order
IF %ERRORLEV% == 1 GOTO House2Order_Failed

Release\GenHouse2Order.exe H="models\myHouse1.mga" O="models\myOrder1.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" myOrder1.mga correct_myOrder1_Model.mga ../udm/GS_Order.xml
IF %ERRORLEVEL%==0 GOTO House2Order_end
echo * The output model myorder1.mga genereated by GenHouse2Order.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:House2Order_end
	IF NOT %ERRORLEV%==0 GOTO House2Order_Failed 
:House2Order_OK
	echo * The Sample House2Order testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO MatchAnyAssoc
:House2Order_Failed
	echo * The Sample House2Order testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO MatchAnyAssoc

REM ======MatchAnyAssoc Sample====================
:MatchAnyAssoc
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample MatchAnyAssoc >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\MatchAnyAssoc"

call ..\runGReATSample.bat testMatchAnyAssoc.mga config.mga testMatchAnyAssoc.udm UmlModel_model.xml correct_UmlModel_model.xml UMLModel.xml GentestMatchAnyAssoc UMLModel.xsd
IF %ERRORLEV% == 1 GOTO MatchAnyAssoc_Failed

Release\GentestMatchAnyAssoc.exe BidirectAssocFileType="models\BidirectAssoc_model.mga" UmlModelFileType="models\UmlModel_model.xml"!"udm\UMLModel.xsd"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" UmlModel_model.xml correct_UmlModel_model.xml ../udm/UMLModel.xml
IF %ERRORLEVEL%==0 GOTO MatchAnyAssoc_end
echo * The output model UmlModel_model.xml genereated by GentestMatchAnyAssoc.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:MatchAnyAssoc_end
	IF NOT %ERRORLEV%==0 GOTO MatchAnyAssoc_Failed 
:MatchAnyAssoc_OK
	echo * The Sample MatchAnyAssoc testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO StateChart
:MatchAnyAssoc_Failed
	echo * The Sample MatchAnyAssoc testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO StateChart

REM ======StateChart Sample====================
:StateChart
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample StateChart >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\StateChart"

call ..\runGReATSample.bat HSM2FSM.mga config.mga HSM2FSM.udm 2Bit_OutSC.mga correct_2Bit_OutSC.mga GS_StateChart.xml GenHSM2FSM
IF %ERRORLEV% == 1 GOTO StateChart_Failed
cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" 2Bit_OutFSM.mga correct_2Bit_OutFSM.mga ../udm/GS_FiniteStateMachine.xml
IF %ERRORLEVEL%==0 GOTO CG 
echo * The output model 2Bit_OutFSM.mga genereated by GRE.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:CG
cd ..
Release\GenHSM2FSM.exe SC="models\2BitCounter.mga";"models\2Bit_OutSC.mga" FSM="models\2Bit_OutFSM.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" 2Bit_OutSC.mga correct_2Bit_OutSC.mga ../udm/GS_StateChart.xml
IF %ERRORLEVEL%==0 GOTO Compare2nd 
echo * The output model 2Bit_OutSC.mga genereated by GenHSM2FSM.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2
:Compare2nd
"%GREAT_PATH%/bin/UdmModelDiff.exe" 2Bit_OutFSM.mga correct_2Bit_OutFSM.mga ../udm/GS_FiniteStateMachine.xml
IF %ERRORLEVEL%==0 GOTO StateChart_end
echo * The output model 2Bit_OutFSM.mga genereated by GenHSM2FSM.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:StateChart_end
	IF NOT %ERRORLEV%==0 GOTO StateChart_Failed 
:StateChart_OK
	echo * The Sample StateChart testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO SF2FSF1
:StateChart_Failed
	echo * The Sample StateChart testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO SF2FSF1

REM ======SignalFlow2FlatSF Sample 1====================
:SF2FSF1
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample SignalFlow2FlatSF >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\SF2FSF"

call ..\runGReATSample.bat SignalFlow2FlatSF.mga config.mga SignalFlow2FlatSF.udm OutFSF1.mga correct_OutFSF1.mga GS_FlatSF.xml GenSF2FSF
IF %ERRORLEV% == 1 GOTO SF2FSF1_Failed

Release\GenSF2FSF.exe SF="models\SignalFlow_1.mga" FSF="models\OutFSF1.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" OutFSF1.mga correct_OutFSF1.mga ../udm/GS_FlatSF.xml
IF %ERRORLEVEL%==0 GOTO SF2FSF1_end
echo * The output model OutFSF1.xml genereated by GenSF2FSF.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:SF2FSF1_end
	IF NOT %ERRORLEV%==0 GOTO SF2FSF1_Failed 
:SF2FSF1_OK
	echo * The Sample SignalFlow2FlatSF testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO SF2FSF2
:SF2FSF1_Failed
	echo * The Sample SignalFlow2FlatSF testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO SF2FSF2

REM ======SignalFlow2FlatSF Sample 2====================
:SF2FSF2
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample SignalFlow2FlatSF_test_globalObject >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\SF2FSF"

call ..\runGReATSample.bat SignalFlow2FlatSF_test_globalObject.mga config.mga SignalFlow2FlatSF.udm OutFSF_testGO.mga correct_OutFSF_testGO.mga GS_FlatSF.xml GenSF2FSF_testGlobalObj
IF %ERRORLEV% == 1 GOTO SF2FSF2_Failed

Release\GenSF2FSF_testGlobalObj.exe SF="models\SignalFlow_1.mga" FSF="models\OutFSF_testGO.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" OutFSF_testGO.mga correct_OutFSF_testGO.mga ../udm/GS_FlatSF.xml
IF %ERRORLEVEL%==0 GOTO SF2FSF2_end
echo * The output model OutFSF_testGO.mga genereated by GenSF2FSF_testGlobalObj.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:SF2FSF2_end
	IF NOT %ERRORLEV%==0 GOTO SF2FSF2_Failed 
:SF2FSF2_OK
	echo * The Sample SignalFlow2FlatSF_test_globalObject testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO SF2FSF3
:SF2FSF2_Failed
	echo * The Sample SignalFlow2FlatSF_test_globalObject testing FAILED. >>  %GREAT_TEST_LOGF%
	GOTO SF2FSF3

REM ======SignalFlow2FlatSF Sample 3====================
:SF2FSF3
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample SignalFlow2FlatSF_test_sortingFunction >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\SF2FSF"

call ..\runGReATSample.bat SignalFlow2FlatSF_test_sortingFunc.mga config.mga SignalFlow2FlatSF.udm OutFSF_testSorting.mga correct_OutFSF_testSorting.mga GS_FlatSF.xml GenSF2FSF_testSorting
IF %ERRORLEV% == 1 GOTO SF2FSF3_Failed

Release\GenSF2FSF_testSorting.exe SF="models\SignalFlow_2.mga" FSF="models\OutFSF_testSorting.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" OutFSF_testSorting.mga correct_OutFSF_testSorting.mga ../udm/GS_FlatSF.xml
IF %ERRORLEVEL%==0 GOTO SF2FSF3_end
echo * The output model OutFSF_testSorting.mga genereated by GenSF2FSF_testSorting.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:SF2FSF3_end
	IF NOT %ERRORLEV%==0 GOTO SF2FSF3_Failed 
:SF2FSF3_OK
	echo * The Sample SignalFlow2FlatSF_test_sortingFunction testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO SF2FSF4
:SF2FSF3_Failed
	echo * The Sample SignalFlow2FlatSF_test_sortingFunction testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO SF2FSF4

REM ======SignalFlow2FlatSF Sample 4====================
:SF2FSF4
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample SignalFlow_test_distinguished >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\SF2FSF"

call ..\runGReATSample.bat SignalFlow_test_distinguished.mga config.mga SignalFlow2FlatSF.udm SignalFlow_connected.mga correct_SignalFlow_connected.mga GS_SignalFlow.xml GenSF2FSF_testDistinguished
IF %ERRORLEV% == 1 GOTO SF2FSF4_Failed

Release\GenSF2FSF_testDistinguished.exe SF="models\SignalFlow_to_connect.mga";"models\SignalFlow_connected.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" SignalFlow_connected.mga correct_SignalFlow_connected.mga ../udm/GS_SignalFlow.xml
IF %ERRORLEVEL%==0 GOTO SF2FSF4_end
echo * The output model SignalFlow_connected.mga genereated by GenSF2FSF_testDistinguished.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:SF2FSF4_end
	IF NOT %ERRORLEV%==0 GOTO SF2FSF4_Failed 
:SF2FSF4_OK
	echo * The Sample SignalFlow_test_distinguished testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO SignalFlowGroup
:SF2FSF4_Failed
	echo * The Sample SignalFlow_test_distinguished testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO SignalFlowGroup

REM ======SignalFlowGroup====================
:SignalFlowGroup
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample SignalFlowGroup >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\SignalFlowGroup"

call ..\runGReATSample.bat MoveSignalFlowGroup.mga config.mga GS_SignalFlowGroup.xml my_newSignalFlow.mga correct_SignalFlowGroup.mga GS_SignalFlowGroup.xml GentestSFGrop
IF %ERRORLEV% == 1 GOTO TestSFGroup_Failed

:TestSFGroup_end
	IF NOT %ERRORLEV%==0 GOTO TestSFGroup_Failed 
:TestSFGroup_OK
	echo * The Sample SignalFlowGroup testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO GroupExample_1
:TestSFGroup_Failed
	echo * The Sample SignalFlowGroup testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO GroupExample_1

REM ======GroupExample_1=====================
:GroupExample_1
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample GroupSample_1 >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\GroupSample_1"

call ..\runGReATSample.bat ex3.mga config.mga ex3.udm mm1_output_small.mga correct_mm1_output_small.mga mm1.xml GenGroupSample_1
IF %ERRORLEV% == 1 GOTO TestSFGroupSample_1_Failed

REM Release\GenGroupSample_1.exe mm1FileType="Models\mm1_input_small.mga";"Models\mm1_output_small.mga"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" mm1_output_small.mga correct_mm1_output_small.mga ../udm/mm1.xml
IF %ERRORLEVEL%==0 GOTO TestSFGroupSample_1_end
echo * The output model mm1_output_small.mga genereated by GenGroupSample_1.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:TestSFGroupSample_1_end
	IF NOT %ERRORLEV%==0 GOTO TestSFGroupSample_1_Failed 
:TestSFGroupSample_1_OK
	echo * The Sample GroupSample_1 testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO GroupSample_2
:TestSFGroupSample_1_Failed
	echo * The GroupSample_1 testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO GroupSample_2

REM ======GroupSample_2====================
:GroupSample_2
echo *						  >>  %GREAT_TEST_LOGF%
echo * Run Sample GroupSample_2 >>  %GREAT_TEST_LOGF%

SET ERRORLEV=0
cd "%GREAT_PATH%\Samples\GroupSample_2"

call ..\runGReATSample.bat EDP2SFC.mga config.mga EDP2SFC.udm dataflowout.xml correct_dataflowout.xml SFC.xml GenGroupSample_2 SFc.xsd
IF %ERRORLEV% == 1 GOTO TestSFGroupSample_2_Failed

REM Release\GenGroupSample_2.exe EDP_test="Models\DataFlowEx.mga" SFC_test="Models\dataflowout.xml"

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" dataflowout.xml correct_dataflowout.xml ../udm/SFC.xml
IF %ERRORLEVEL%==0 GOTO TestSFGroupSample_2_end
echo * The output model dataflowout.xml genereated by GenGroupSample_2.exe is not correct >>  %GREAT_TEST_LOGF%
set ERRORLEV=2

:TestSFGroupSample_2_end
	IF NOT %ERRORLEV%==0 GOTO TestSFGroupSample_2_Failed 
:TestSFGroupSample_2_OK
	echo * The Sample GroupSample_2 testing SUCCESSED. >>  %GREAT_TEST_LOGF%
	GOTO End
:TestSFGroupSample_2_Failed
	echo * The GroupSample_2 testing FAILED. >>  %GREAT_TEST_LOGF%
        set TESTSFAILED=1
	GOTO End

:End
IF NOT %TESTSFAILED%==0 set ERRORLEVEL=1