#ifndef CINTLIBRARYCALL_H
#define CINTLIBRARYCALL_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif

#include <map>
#include "RuleTypes.h"
#include "PE.h"

#include "ICIntCompiler.h"
#include "CIntCompiler.h"

class CIntLibraryCall :  virtual public ICIntCompiler , virtual private CIntCompiler
{
public:
	CIntLibraryCall() : _rule( 0), _boundObjects( 0)
	{}
	// user must call init() before use.
	void init( const GRSimpleRule& rule, 
		const std::map< GR::ObjectWrapper, std::string>& boundObjects,
		Class& cl 
		) 
	{
		_rule= &rule;
		_boundObjects= &boundObjects;
		CIntCompiler::init( rule, boundObjects, cl);
	}
	// Returns true, if '_rule' has guard defined.
	bool isGuard() const;
	// Returns true, if '_rule' has any attribute mapping code elements.
	bool isCode() const;
	// Create code into 'code', which executes guards.
	// Returns with the guard variable name.
	const std::string createGuard( PEComposite& code);
	// Create code into 'code', which executes attribute mapping code elements.
	void createCode( PEComposite& code);

protected:
	//
	std::string createObjectVector( PEComposite& addTo) const;
	void fillObjectVector( const std::string objVecName, PEComposite& addTo) const;
	std::string createErrVariable(  PEComposite& addTo) const;

private:
	// Rule of which CInt expression strings are being compiled.
	const GRSimpleRule* _rule;
	// Maps object wrappers in '_rule' to their generated variable names.
	const std::map< GR::ObjectWrapper, std::string>* _boundObjects;
};

#endif //CINTLIBRARYCALL_H