#ifndef CINTCOMPILER_H
#define CINTCOMPILER_H

#include <string>
#include "PE.h"

class ICIntCompiler
{
public:
	virtual void init( const GRSimpleRule& rule, 
		const std::map< GR::ObjectWrapper, std::string>& boundObjects,
		Class& addGuardFuncDefTo
		) = 0; 
	// Returns true, if '_rule' has guard defined.
	virtual bool isGuard() const = 0;
	// Returns true, if '_rule' has any attribute mapping code elements.
	virtual bool isCode() const = 0;
	// Create code into 'code', which executes guards.
	// Returns with the guard variable name.
	virtual const std::string createGuard( PEComposite& code) = 0;
	// Create code into 'code', which executes attribute mapping code elements.
	virtual void createCode( PEComposite& code) = 0;
	virtual void createGroupRule( PEComposite& code, GR::PatternGroup& group) = 0;
	virtual void buildOWNameMap(bool onlyBoundObjects, std::map< std::string, std::pair< GR::ObjectWrapper, bool> >& nameMap)=0;
};

#endif //CINTCOMPILER_H