#include "CopyToMemDNCodePrinter.h"
#include "../CodeGenerator/PEStringTable.h"
#include "GReATUtils.h"

std::string CopyToMemDNCodePrinter::_dnsVecName= "";
std::string CopyToMemDNCodePrinter::_udmProjectName= "";

void CopyToMemDNCodePrinter::generateCreateMemDN( const std::string& hostFileName, const std::string& meta, const std::string& paradigm, const std::string& root, const std::string& dtd)
{
	// Udm::SmartDataNetwork mem_<meta>( <meta>::diagram);
	_memDNDef= constructObj( _memDNDef);
	_memDNDef->_type= "Udm::SmartDataNetwork";
	_memDNDef->_variable= PE::createUniqueName( "mem_"+ meta);
	_memDNDef->addArg( meta+ RES+ "diagram");
	// mem_<meta>.CreateNew( <meta>_id.mem, UseXsd()( <hostFileName> ? <dtd> : <meta>, <meta>::<root>::meta, "Udm::CHANGES_LOST_DEFAULT");
	_memDNCreateExpr= constructObj( _memDNCreateExpr);
	std::string metalocator= "UseXSD()("+ SEP+ hostFileName+ ") ? "+ dtd+ " : \"" + paradigm + "\"";
	_memDNCreateExpr->_expression= _memDNDef->_variable+ ".CreateNew(" + SEP+ "\""+ PE::createUniqueName( meta)+ ".mem\","+ SEP+
		metalocator+ ","+  SEP+ meta+ RES+ root+ RES+ "meta,"+ SEP+ "Udm::CHANGES_LOST_DEFAULT" + ")";
}

void CopyToMemDNCodePrinter::generateCopyMemDN( const std::string& lhs, const std::string& rhs)
{
	// lhs= rhs
	_memCopyExpr= constructObj( _memCopyExpr);
	_memCopyExpr->_expression= lhs+ EQ+ SEP+ rhs;
}

void CopyToMemDNCodePrinter::addCreateMemCode( PEComposite& addTo) const
{	
	if ( _memDNDef) addTo.add( *_memDNDef);
	if ( _memDNCreateExpr) addTo.add( *_memDNCreateExpr);
}

void CopyToMemDNCodePrinter::addCopyMemCode( PEComposite& addTo) const
{
	if ( _memCopyExpr) addTo.add( *_memCopyExpr);
}

void ReadWriteCopyToMemDNCodePrinter::generateCopyBackDN()
{
	_copyBackExpr= constructObj( _copyBackExpr);
	_copyBackExpr->_expression= ReadDNProjectCodePrinter::getSdnFileName()+ EQ+ SEP+ getMemFileName();
}

void WriteCopyCopyToMemDNCodePrinter::generateSaveAsDN()
{
	_saveAsExpr= constructObj( _saveAsExpr);
	_saveAsExpr->_expression= ReadDNProjectCodePrinter::getSdnFileName()+ ".SaveAs(" + SEP+ _copyName+ ")";
}

