#include "GRCC.h"
#include "GRCforCG.h"
#include "GReATConfig.h"

#include "GReATUtils.h"
#include "GR.h"
#include <algorithm> // for transform()

void createGRC( GReATConfigMeta& metaInfo, const std::string& configPath, GReATConfigMeta::MetaCodeGenModes mcgm) {
	CCodeGenConfig cc_cfg;
	cc_cfg._transFileName= GReATConfigMeta::getFullPath( configPath, metaInfo.getTransformationFileName());
	cc_cfg._depFileName= cc_cfg._transFileName;
	cc_cfg._udmDirName= getPath( GReATConfigMeta::getFullPath( configPath, metaInfo.getUdmProjectFileName()), false);
	//
	typedef std::map< std::string, const Udm::DataNetwork*> BackendMap_t;
	BackendMap_t dns;
	metaInfo.getGeneralBackend( dns, configPath);
	StrList_t metanames;
	getFirst( std::make_pair( std::string(), (const Udm::DataNetwork*) 0));	// template instantiation to satisfy the linker
	std::transform( dns.begin(), dns.end(), std::back_inserter( metanames), getFirst< std::string, const Udm::DataNetwork*>);
	if ( metaInfo.isUdmProjectFile()) {
		metanames.push_back( metaInfo.getCrossLinkDiagramName());
	}
	cc_cfg._metas= metanames;
	//
	cc_cfg._debug = GReATConfigMeta::isLibraryDebug( mcgm);
	cc_cfg._dynamic= false;
	//
//	UdmDom::DomDataNetwork ddn( Uml::diagram);
//	ddn.OpenExisting( "d:\\project\\mobiestransition\\GReAT\\libraries\\GRAPI\\GR.xml", "Uml.xsd");
//	Uml::Diagram grRoot= Uml::Diagram::Cast( ddn.GetRootObject());
//	GR::Initialize( grRoot);
//	GRCC grcc( cc_cfg, grRoot);
	//
	GRCC grcc( cc_cfg);
	grcc.generateLibrary();
	//
	CCodeGenforCGConfig cc_cfg_cg= cc_cfg;
	cc_cfg_cg._useLib= GReATConfigMeta::isLibraryToGenerate( metaInfo.getMetaCodeGenMode());
	cc_cfg_cg._genFileName= 
	GRCforCG grcforcg( cc_cfg_cg);
}
