#include "CINTCodeGathererFactory.h"
#include "GReATConfig.h"
#include "GReATConfigMeta.h"
#include "GReATUtils.h"

void createUserCodeLibrary( GReATConfigMeta& metaInfo, const std::string& configPath, GReATConfigMeta::MetaCodeGenModes mcgm)
{
	UserCodeGenConfig cfg;
	//
	cfg.m_depFileName= getFullPath( configPath, metaInfo.getTransformationFileName());
	cfg.m_transf= &metaInfo.getTransformationDN( configPath);
	cfg.m_udmDirName= getPath( getFullPath( configPath, metaInfo.getUdmProjectFileName()), true);
	//
	typedef std::map< std::string, const Udm::DataNetwork*> BackendMap_t;
	BackendMap_t dns;
	metaInfo.getGeneralBackend( dns, configPath);
	StrUmlDiagramMap diagMap;
	for( BackendMap_t::const_iterator it= dns.begin(); it!= dns.end(); ++it) {
		diagMap[ it->first]= Uml::Diagram::Cast( it->second->GetRootObject()); 
	}
	if ( metaInfo.isUdmProjectFile()) {
		Uml::Diagram xLinkDiagram;
		metaInfo.getCrossLinkDiagram( xLinkDiagram);
		diagMap[ metaInfo.getCrossLinkDiagramName()]= xLinkDiagram;
	}
	cfg.m_metas= diagMap;
	//
//	StrVec tokens;
//	tokenize_csv_lines( metaInfo.incFiles(), tokens);
//	cfg.m_incFiles= tokens;
//	tokenize_csv_lines( metaInfo.libFiles(), tokens);
//	cfg.m_libFiles= tokens;
//	tokenize_csv_lines( metaInfo.incDirs(), tokens);
//	cfg.m_incDirs= tokens;
//	tokenize_csv_lines( metaInfo.libDirs(), tokens);
//	cfg.m_libDirs= tokens;

	cfg.m_debug = GReATConfigMeta::isLibraryDebug( mcgm);

	//
	ICINTCodeGatherer* codeGatherer= CINTCodeGathererFactory::create();
	codeGatherer->generateDll( cfg);
}