#if !defined(IGRDFrontEnd_h)
#define IGRDFrontEnd_h
#include "../GRDebugInterface/GRDebugTypes.h"

namespace GRDI
{
class DebugInterface;
class GRDebugNotification;

class IGRDFrontEnd
{
  public:

  virtual ~IGRDFrontEnd() {}
  virtual void setBackEnd(DebugInterface*) = 0;
  virtual void setNotificationInterface(GRDebugNotification*) = 0;

  virtual void init() = 0;
  virtual void run() = 0;
  virtual void wait_up() = 0;
  virtual void stop() = 0;
  

  virtual bool setBreakpointCmd(const LocationID&) = 0;
  virtual bool clearBreakpoint(const LocationID& ) = 0;
  virtual void clearAllBreakpoints() = 0;

  virtual void saveCmd() = 0;
  virtual void loadCmd(const std::string& pn) = 0;
  virtual void closeCmd() = 0;
  virtual void startCmd() = 0;
  virtual void runCmd() = 0;
  virtual void stopCmd() = 0;
  virtual void pauseCmd() = 0;
  virtual void quitCmd() = 0;
  virtual void nextCmd() = 0;
  virtual void stepCmd() = 0;
  virtual void stepOutCmd() = 0;
//x  virtual void updateSourceDescr() = 0;
//x  virtual const FunctionDescrMap& getFuncDescrMap() const = 0;
//x  virtual const LocLocIDMap& getLocLocIDMap() const = 0;
//x  virtual const LocIDLocMap& getLocIDLocMap() const = 0;

  virtual DebugInterface& getDebugInterface() = 0;
};
//==========================================================
class GRDebugNotification
{
  public:

  virtual ~GRDebugNotification() {}

  virtual void eventHandligStart() = 0;
  virtual void eventHandligFinish() = 0;
  virtual void breakpoint(const GRDI::LocationID& loc, bool pause) = 0;
  virtual void stepIn(const GRDI::LocationID& loc) = 0;
  virtual void step(const GRDI::LocationID& loc) = 0;
  virtual void stepOut(const GRDI::LocationID& loc) = 0;
  virtual void ctxPop(const GRDI::LocationID& loc) = 0;
  virtual void stopped() = 0;
  virtual void exception(const GRDI::LocationID& loc) = 0;
  virtual void start() = 0;
  virtual void finish() = 0;
  virtual void engineIsUp() = 0;
  virtual void engineIsDown() = 0;
  virtual void saved() = 0;
  virtual void loaded() = 0;
  virtual void closed() = 0;
  virtual void progress(double) = 0;
};

}; //namespace GRDI
#endif